/* file: echo.h

   The macro CHECK is used to check that the value returned by a
   system call is nonzero, and terminate the program immediately if
   this check fails.
 */

#ifndef ECHO_H

#define ECHO_H
#define CHECK(CALL)\
 if ((CALL) < 0) {\
    perror (#CALL);\
    _exit (-1);\
 }

#define ERR_QUIT(MSG) {\
 perror (MSG);\
 _exit (-1);\
 }

#define ERR_QUIT_2(MSG, ERRNO) {\
 fprintf (stderr, "%s: %s\n", (MSG), strerror(ERRNO));\
 _exit (-1);\
 }

#define SERV_PORT 11112
#define LISTENQ 4
#define SA struct sockaddr
#define MAXLINE 1024

typedef void Sigfunc(int);

extern void str_cli(int fd, int sockfd);
extern void str_echo(int sockfd);
extern ssize_t readline(int fd, void *vptr, size_t maxlen);
extern ssize_t Readline(int fd, void *ptr, size_t maxlen);
extern ssize_t writen(int fd, const void *vptr, size_t n);
extern void Writen (int fd, void *ptr, size_t nbytes);
extern ssize_t readline_r(int fd, void *vptr, size_t maxlen);

#endif
