#include "config.h"
#include "echo.h"
#include <pthread.h>

#define MAXTHREAD  2

#define CONNECTING 1
#define DONE       2
#define JOINED     3

struct t_access {
    int fd;
    int tid;
    int flag;
} t_access[MAXTHREAD];

pthread_mutex_t M;
pthread_mutexattr_t mattr;
pthread_cond_t C;
pthread_cond_t GC;
pthread_condattr_t cattr;

int empty = 1; /* TRUE */
int ndone;
int gfd = -2;

void *thread_body (void * vptr) 
{
    int i, n;
    char buf[2000];

    char recvline[20];
    struct t_access *ptr;
    int connfd;

    ptr = (struct t_access *) vptr;
    printf ("thread starting to serve fd %d - tid %d\n", connfd, ptr->tid);
    fflush (stdout);

    for (;;) {
        pthread_mutex_lock(&M);
        while ( gfd < 0 ) 
            pthread_cond_wait(&C, &M);
        connfd = gfd;
        gfd = -2;
        pthread_mutex_unlock(&M);

        sleep(4);

        snprintf(buf, sizeof(buf), "Hello");
          
        if ( (n = read(connfd, recvline, 20)) != 0 ) {
            printf("recvline:%s - fd:%d %d\n", recvline, connfd, ptr->tid);
            strncat(buf, ":", 1);
            for (i=0; i<350; i++) {
                strncat(buf, recvline, 5);
            }
            
        }
        if ( ptr->tid == 1026 ) sleep(3);
        if (recvline[0] == 'H') {
            write(connfd, buf, 1757);
        }
    
        snprintf(buf, sizeof(buf), "Second");
        n = write (connfd, buf, 7);

        close(connfd);
	pthread_cond_signal(&GC);
    }
    
    return (ptr);
}
    
int
main(int argc, char **argv)
{
   int i;
   int listenfd, connfd;
   socklen_t clilen;
   struct sockaddr_in cliaddr, servaddr;
   int result;
   pthread_t tid;
   pthread_attr_t attr;
   /*struct t_access *ptr;*/

   for (i=0; i < MAXTHREAD; i++) {
       t_access[i].flag = 0;
   }
   
   if ( (listenfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
      ERR_QUIT ("socket");
   }

   memset (&servaddr, 0, sizeof(servaddr));
   servaddr.sin_family      = AF_INET;
   servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
   servaddr.sin_port        = htons(SERV_PORT);

   CHECK (bind (listenfd, (SA *) &servaddr, sizeof (servaddr)));

   CHECK (listen (listenfd, LISTENQ));

   pthread_mutex_init (&M, NULL);
   pthread_cond_init (&C, NULL);
   pthread_cond_init (&GC, NULL);

   pthread_attr_init (&attr);
   pthread_attr_setdetachstate (&attr, PTHREAD_CREATE_DETACHED);
   
   for (i=0; i<MAXTHREAD; i++) {
       result = pthread_create(&tid, NULL, thread_body, &t_access[i]);
       if (result) ERR_QUIT_2 ("thread creation", result);
       t_access[i].tid = tid;
   }
   
   for ( ; ; ) {
      clilen = sizeof(cliaddr);
      
      if ( (connfd = accept(listenfd, (SA *) &cliaddr, &clilen)) < 0) {
          ERR_QUIT ("accept");
      }

      printf("accepted\n");
      pthread_mutex_lock(&M);
      printf ("gfd:%d\n", gfd);
      while ( gfd > -1 )
          pthread_cond_wait(&GC, &M);
      gfd = connfd;
      pthread_cond_signal(&C);
      pthread_mutex_unlock(&M);
   }
   
   return 0;
}





